(comment "CPSA 2.1.2")
(comment "All input read")

(defprotocol nsl4cm basic
  (defrole init
    (vars (a b c d name) (na nb nc nd text))
    (trace (send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b)))))
  (defrole resp1
    (vars (a b c d name) (na nb nc nd text))
    (trace (recv (enc a c d na (pubk b)))
      (send (enc a b d na nb (pubk c))) (recv (enc nb nc nd (pubk b)))
      (send (enc nc nd (pubk c)))))
  (defrole resp2
    (vars (a b c d name) (na nb nc nd text))
    (trace (recv (enc a b d na nb (pubk c)))
      (send (enc a b c na nb nc (pubk d))) (recv (enc nc nd (pubk c)))
      (send (enc nd (pubk d)))))
  (defrole resp3
    (vars (a b c d name) (na nb nc nd text))
    (trace (recv (enc a b c na nb nc (pubk d)))
      (send (enc b c d na nb nc nd (pubk a)))
      (recv (enc nd (pubk d))))))

(defskeleton nsl4cm
  (vars (na nb nc nd text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b)))))
  (label 0)
  (unrealized (0 1))
  (comment "1 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((1 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (0 1)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-0 (pubk c)))))
  (label 1)
  (parent 0)
  (unrealized (0 1))
  (comment "1 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (2 0)) ((1 1) (0 1)) ((2 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (0 1)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d)))))
  (label 2)
  (parent 1)
  (unrealized (0 1) (2 0))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (2 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 3)
  (parent 2)
  (unrealized (0 1) (2 0))
  (comment "4 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 3 1 resp1 2) na (2 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d)))))
  (label 4)
  (parent 2)
  (unrealized (0 1))
  (comment "1 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 3 1 resp1 2) na (2 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d)))))
  (label 5)
  (parent 2)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-1 nb-0)) na (2 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-0 (pubk c)))))
  (label 6)
  (parent 3)
  (unrealized (0 1))
  (comment "1 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 4 1 resp1 2) na (2 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 7)
  (parent 3)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 4 1 resp1 2) na (2 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 8)
  (parent 3)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (4 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (2 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 9)
  (parent 3)
  (unrealized (0 1) (2 0) (4 0))
  (comment "5 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b d na nb-0 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 10)
  (parent 4)
  (unrealized (0 1) (3 0))
  (comment "4 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 11)
  (parent 5)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 12)
  (parent 5)
  (seen 25)
  (unrealized (0 1) (3 0))
  (comment "4 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (4 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b d na nb-0 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 13)
  (parent 6)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (4 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b d na nb-0 (pubk c))
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 14)
  (parent 7)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (4 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b d na nb-0 (pubk c))
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 15)
  (parent 7)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (4 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 16)
  (parent 8)
  (seen 40)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (4 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 17)
  (parent 8)
  (seen 46)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 18)
  (parent 9)
  (unrealized (0 1) (2 0) (4 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 1 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 19)
  (parent 9)
  (unrealized (0 1) (4 0))
  (comment "4 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 20)
  (parent 9)
  (unrealized (0 1) (2 0))
  (comment "4 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 1 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 21)
  (parent 9)
  (seen 60)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 22)
  (parent 9)
  (seen 71)
  (unrealized (0 1) (2 0))
  (comment "5 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (3 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 23)
  (parent 10)
  (unrealized (0 1) (3 0))
  (comment "5 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((1 1) (3 0)) ((2 1) (0 1))
    ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 4 1 resp1 2) na (3 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 24)
  (parent 10)
  (seen 26)
  (unrealized (0 1) (3 0))
  (comment "3 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((1 1) (3 0)) ((2 1) (0 1))
    ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 4 1 resp1 2) na (3 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 25)
  (parent 10)
  (seen 30 80)
  (unrealized (0 1) (3 0))
  (comment "4 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 4 2 resp2 2) na (3 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 26)
  (parent 10)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (4 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 27)
  (parent 11)
  (seen 91)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (4 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 28)
  (parent 11)
  (seen 29 34 95)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (3 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 29)
  (parent 12)
  (seen 80)
  (unrealized (0 1) (3 0))
  (comment "5 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 4 2 resp2 2) nb-0 (3 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 30)
  (parent 12)
  (seen 96)
  (unrealized (0 1))
  (comment "3 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 31)
  (parent 13)
  (unrealized (0 1) (4 0))
  (comment "7 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 1 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 32)
  (parent 13)
  (seen 82)
  (unrealized (0 1) (4 0))
  (comment "3 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 33)
  (parent 13)
  (seen 36)
  (unrealized (0 1) (4 0))
  (comment "3 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 1 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 34)
  (parent 13)
  (seen 98 104)
  (unrealized (0 1) (4 0))
  (comment "4 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 35)
  (parent 13)
  (seen 105)
  (unrealized (0 1) (4 0))
  (comment "4 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 36)
  (parent 13)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 37)
  (parent 14)
  (unrealized (0 1) (4 0))
  (comment "8 in cohort - 8 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 1 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 38)
  (parent 14)
  (seen 42 64)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 39)
  (parent 14)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 1 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 40)
  (parent 14)
  (seen 51 52 65 123 130)
  (unrealized (0 1) (4 0))
  (comment "7 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 41)
  (parent 14)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d)))))
  (label 42)
  (parent 14)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 43)
  (parent 15)
  (unrealized (0 1) (4 0))
  (comment "7 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 1 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 44)
  (parent 15)
  (seen 48)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 45)
  (parent 15)
  (seen 48 148)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 1 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 46)
  (parent 15)
  (seen 56 143 152)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 47)
  (parent 15)
  (seen 144 149)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 48)
  (parent 15)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (4 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 49)
  (parent 16)
  (seen 123)
  (unrealized (0 1) (4 0))
  (comment "8 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 3 resp1 2) nb-0 (4 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 50)
  (parent 16)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 3 resp1 2) nb-1 (4 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 51)
  (parent 16)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-1 (4 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 52)
  (parent 16)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (4 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 53)
  (parent 17)
  (seen 143)
  (unrealized (0 1) (4 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 3 resp1 2) nb-0 (4 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 54)
  (parent 17)
  (seen 56 152 158)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 3 resp1 2) nb-1 (4 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 55)
  (parent 17)
  (seen 158 178)
  (unrealized (0 1) (4 0))
  (comment "4 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-1 (4 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 56)
  (parent 17)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-2 nb-1)) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 57)
  (parent 18)
  (unrealized (0 1) (2 0))
  (comment "4 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 58)
  (parent 18)
  (seen 126)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 59)
  (parent 18)
  (unrealized (0 1) (2 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 60)
  (parent 18)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 61)
  (parent 18)
  (seen 204)
  (unrealized (0 1) (2 0))
  (comment "6 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 62)
  (parent 18)
  (unrealized (0 1) (2 0) (4 0) (6 0))
  (comment "7 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-1 nb-0)) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 63)
  (parent 19)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 64)
  (parent 19)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 65)
  (parent 19)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d)))))
  (label 66)
  (parent 19)
  (unrealized (0 1) (4 0) (5 0))
  (comment "5 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-1 nb-0)) na (2 0)
    (enc a b c na nb-0 nc-1 (pubk d)) (enc a b d na nb-0 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 67)
  (parent 20)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 1 resp1 2) na (2 0)
    (enc a b c na nb-1 nc-1 (pubk d)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 68)
  (parent 20)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 1 resp1 2) na (2 0)
    (enc a b c na nb-1 nc-1 (pubk d)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 69)
  (parent 20)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (2 0)
    (enc a b c na nb-1 nc-1 (pubk d)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 70)
  (parent 20)
  (unrealized (0 1) (2 0) (5 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-1 nb-0)) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 71)
  (parent 21)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 3 resp1 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 72)
  (parent 21)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 3 resp1 2) nb-1 (4 0)
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 73)
  (parent 21)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 74)
  (parent 21)
  (seen 230)
  (unrealized (0 1) (4 0) (5 0))
  (comment "5 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-1 nb-0)) nb-0 (2 0)
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 75)
  (parent 22)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp1 2) nb-1 (2 0)
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 76)
  (parent 22)
  (unrealized (0 1) (2 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 5 1 resp1 2) nb-1 (2 0)
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 77)
  (parent 22)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (2 0)
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 78)
  (parent 22)
  (seen 242)
  (unrealized (0 1) (2 0) (5 0))
  (comment "6 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((1 1) (3 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 1 resp1 2) na (3 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 79)
  (parent 23)
  (seen 82 83)
  (unrealized (0 1) (3 0))
  (comment "5 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((1 1) (3 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 1 resp1 2) na (3 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 80)
  (parent 23)
  (seen 98 99)
  (unrealized (0 1) (3 0))
  (comment "5 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (3 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 81)
  (parent 23)
  (unrealized (0 1) (3 0) (5 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 2 resp2 2) na (3 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-0 (pubk c)))))
  (label 82)
  (parent 23)
  (unrealized (0 1))
  (comment "1 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) na (3 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 83)
  (parent 23)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((1 1) (3 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (3 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 84)
  (parent 24)
  (unrealized (0 1) (3 0) (4 0))
  (comment "4 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 4 2 resp2 2) na (3 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 85)
  (parent 24)
  (unrealized (0 1))
  (comment "1 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((1 1) (3 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (3 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 86)
  (parent 25)
  (seen 288)
  (unrealized (0 1) (3 0) (4 0))
  (comment "4 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 4 2 resp2 2) nb-0 (3 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 87)
  (parent 25)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd text) (a b c d name))
  (defstrand init 3 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nb nc (pubk d)) (enc a b d nc nb (pubk c))
    (enc a c d nc (pubk b)) (enc b c d nc nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b d nc nb (pubk c)))
      (send (enc a b c nc nb nc (pubk d))))
    ((recv (enc a b c nc nb nc (pubk d)))
      (send (enc b c d nc nb nc nd (pubk a)))))
  (label 88)
  (parent 26)
  (seen 290)
  (unrealized)
  (comment "1 in cohort - 0 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 89)
  (parent 26)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (4 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 90)
  (parent 27)
  (seen 301)
  (unrealized (0 1) (4 0))
  (comment "8 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 1 resp1 2) nb-0 (4 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 91)
  (parent 27)
  (seen 22 41 51 94 301)
  (unrealized (0 1) (4 0))
  (comment "7 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 3 resp1 2) nb-0 (4 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 92)
  (parent 27)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 3 resp1 2) nb-1 (4 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 93)
  (parent 27)
  (seen 312)
  (unrealized (0 1))
  (comment "3 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-1 (4 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 94)
  (parent 27)
  (seen 306)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 1 resp1 2) nb-0 (4 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 95)
  (parent 28)
  (seen 80 96 294)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-1 (4 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 96)
  (parent 28)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (3 0)
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 97)
  (parent 29)
  (seen 279)
  (unrealized (0 1) (3 0) (5 0))
  (comment "6 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-0 (3 0)
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c)))))
  (label 98)
  (parent 29)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nb-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-1 (3 0)
    (enc a b d nb-1 nb-0 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c)))))
  (label 99)
  (parent 29)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nc nd text) (a b c d name))
  (defstrand init 3 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nc) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb nc) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nc nc (pubk d)) (enc a b d nc nc (pubk c))
    (enc a c d nc (pubk b)) (enc b c d nc nc nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nc nc nd (pubk a)))
      (send (enc nc nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b d nc nc (pubk c)))
      (send (enc a b c nc nc nc (pubk d))))
    ((recv (enc a b c nc nc nc (pubk d)))
      (send (enc b c d nc nc nc nd (pubk a)))))
  (label 100)
  (parent 30)
  (seen 293)
  (unrealized)
  (comment "1 in cohort - 0 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 101)
  (parent 30)
  (seen 297)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 102)
  (parent 31)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 103)
  (parent 31)
  (seen 107 108)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 104)
  (parent 31)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 105)
  (parent 31)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 106)
  (parent 31)
  (unrealized (0 1) (4 0) (6 0))
  (comment "8 in cohort - 8 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-0 (pubk c)))))
  (label 107)
  (parent 31)
  (unrealized (0 1))
  (comment "1 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 108)
  (parent 31)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 109)
  (parent 32)
  (seen 324)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 110)
  (parent 32)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 111)
  (parent 33)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 2 resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 112)
  (parent 33)
  (unrealized (0 1))
  (comment "1 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 113)
  (parent 34)
  (seen 324 367)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 114)
  (parent 34)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 115)
  (parent 35)
  (seen 374 375)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 116)
  (parent 35)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 117)
  (parent 35)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nc nb nd text) (a b c d name))
  (defstrand init 3 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nb nc (pubk d)) (enc a b d nc nb (pubk c))
    (enc a c d nc (pubk b)) (enc b c d nc nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b d nc nb (pubk c)))
      (send (enc a b c nc nb nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b c nc nb nc (pubk d)))
      (send (enc b c d nc nb nc nd (pubk a)))))
  (label 118)
  (parent 36)
  (seen 88)
  (unrealized)
  (comment "1 in cohort - 0 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 119)
  (parent 36)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-2 nb-1)) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 120)
  (parent 37)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 121)
  (parent 37)
  (seen 126 127)
  (unrealized (0 1) (4 0))
  (comment "9 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 122)
  (parent 37)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 123)
  (parent 37)
  (seen 165 167 168)
  (unrealized (0 1) (4 0))
  (comment "9 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 124)
  (parent 37)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 125)
  (parent 37)
  (unrealized (0 1) (4 0) (6 0))
  (comment "8 in cohort - 8 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-0 (pubk c)))))
  (label 126)
  (parent 37)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c)))))
  (label 127)
  (parent 37)
  (unrealized (0 1))
  (comment "4 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-1 nb-0)) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 128)
  (parent 38)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 129)
  (parent 38)
  (seen 434)
  (unrealized (0 1))
  (comment "2 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 130)
  (parent 38)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d)))))
  (label 131)
  (parent 38)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 132)
  (parent 39)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 133)
  (parent 39)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 3 resp1 2) nb-1 (4 0)
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 134)
  (parent 40)
  (seen 458)
  (unrealized (0 1))
  (comment "3 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 135)
  (parent 40)
  (seen 440)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 136)
  (parent 41)
  (seen 447)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 137)
  (parent 41)
  (seen 454)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-1 nc-1 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-2 (pubk d)))))
  (label 138)
  (parent 42)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp3 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-1 nc-1 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 139)
  (parent 42)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp3 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-1 nc-1 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 140)
  (parent 42)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 141)
  (parent 43)
  (seen 146 147)
  (unrealized (0 1) (4 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 142)
  (parent 43)
  (seen 146 147 494)
  (unrealized (0 1) (4 0))
  (comment "7 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 143)
  (parent 43)
  (seen 180 181 499)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 144)
  (parent 43)
  (seen 495)
  (unrealized (0 1) (4 0))
  (comment "6 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-1 (pubk d)))))
  (label 145)
  (parent 43)
  (unrealized (0 1) (4 0) (6 0))
  (comment "8 in cohort - 8 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-0 (pubk c)))))
  (label 146)
  (parent 43)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c)))))
  (label 147)
  (parent 43)
  (unrealized (0 1))
  (comment "4 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 148)
  (parent 44)
  (seen 48 151 154)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 5 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 149)
  (parent 44)
  (seen 158 159)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 150)
  (parent 44)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 2 resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 151)
  (parent 44)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 1 resp1 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 152)
  (parent 45)
  (seen 56 156 158)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 153)
  (parent 45)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 2 resp2 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 154)
  (parent 45)
  (unrealized (0 1))
  (comment "1 in cohort - 1 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 155)
  (parent 46)
  (seen 533)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 156)
  (parent 46)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 157)
  (parent 47)
  (seen 544 549)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 158)
  (parent 47)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 159)
  (parent 47)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nb-0 nd text) (a b c d name))
  (defstrand init 3 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-1 nb) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nb nc (pubk d)) (enc a b d nc nb (pubk c))
    (enc a b d nc nb-0 (pubk c)) (enc a c d nc (pubk b))
    (enc b c d nc nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b d nc nb (pubk c)))
      (send (enc a b c nc nb nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb-0 (pubk c))))
    ((recv (enc a b c nc nb nc (pubk d)))
      (send (enc b c d nc nb nc nd (pubk a)))))
  (label 160)
  (parent 48)
  (seen 88)
  (unrealized)
  (comment "1 in cohort - 0 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 161)
  (parent 48)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 7 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d)))))
  (label 162)
  (parent 48)
  (seen 448 466 492)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-2 nb-1)) nb-0 (4 0)
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 163)
  (parent 49)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-0 (4 0)
    (enc a b d nb-0 nb-2 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 164)
  (parent 49)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-2 (4 0)
    (enc a b d nb-2 nb-1 (pubk c)) (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 165)
  (parent 49)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-2 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 166)
  (parent 49)
  (seen 422)
  (unrealized (0 1) (4 0) (6 0))
  (comment "8 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-2 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c)))))
  (label 167)
  (parent 49)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-2 (4 0)
    (enc a b d nb-2 nb-1 (pubk c)) (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 168)
  (parent 49)
  (unrealized (0 1))
  (comment "4 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 169)
  (parent 50)
  (seen 453)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 170)
  (parent 50)
  (seen 446)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 171)
  (parent 51)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 172)
  (parent 51)
  (seen 465 599)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 173)
  (parent 51)
  (seen 470 594)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-0 nc-1 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-2 (pubk d)))))
  (label 174)
  (parent 52)
  (seen 476)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp3 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-0 nc-1 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 175)
  (parent 52)
  (seen 483)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp3 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-0 nc-1 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 176)
  (parent 52)
  (seen 490)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-0 (4 0)
    (enc a b d nb-0 nb-2 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 177)
  (parent 53)
  (seen 180 181 499 509)
  (unrealized (0 1) (4 0))
  (comment "7 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-2 (4 0)
    (enc a b d nb-2 nb-1 (pubk c)) (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 178)
  (parent 53)
  (seen 509)
  (unrealized (0 1) (4 0))
  (comment "5 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-2 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-1 (pubk d)))))
  (label 179)
  (parent 53)
  (seen 515)
  (unrealized (0 1) (4 0) (6 0))
  (comment "8 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-2 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c)))))
  (label 180)
  (parent 53)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-2 (4 0)
    (enc a b d nb-2 nb-1 (pubk c)) (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 181)
  (parent 53)
  (unrealized (0 1))
  (comment "4 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 182)
  (parent 54)
  (seen 543)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 183)
  (parent 55)
  (seen 549 646)
  (unrealized (0 1) (4 0) (5 0))
  (comment "6 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 184)
  (parent 55)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nc nb nd text) (a b c d name))
  (defstrand init 3 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nc) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-0 nc) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nc nc (pubk d)) (enc a b d nc nc (pubk c))
    (enc a b d nc nb (pubk c)) (enc a c d nc (pubk b))
    (enc b c d nc nc nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nc nc nd (pubk a)))
      (send (enc nc nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b d nc nc (pubk c)))
      (send (enc a b c nc nc nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b c nc nc nc (pubk d)))
      (send (enc b c d nc nc nc nd (pubk a)))))
  (label 185)
  (parent 56)
  (seen 100)
  (unrealized)
  (comment "1 in cohort - 0 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 186)
  (parent 56)
  (seen 570 600 606 624)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 187)
  (parent 56)
  (seen 564 606)
  (unrealized (0 1) (5 0))
  (comment "7 in cohort - 4 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nc-1 nb-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-1 nb-0)) na (2 0)
    (enc a b c na nb-0 nc-1 (pubk d)) (enc a b d na nb-0 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-0 (pubk c)))))
  (label 188)
  (parent 57)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (2 0)
    (enc a b c na nb-1 nc-1 (pubk d)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 189)
  (parent 57)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (2 0)
    (enc a b c na nb-1 nc-1 (pubk d)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 190)
  (parent 57)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (2 0)
    (enc a b c na nb-1 nc-1 (pubk d)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 191)
  (parent 57)
  (unrealized (0 1) (2 0) (6 0))
  (comment "8 in cohort - 8 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-2 nb-0)) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 192)
  (parent 58)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 193)
  (parent 58)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 194)
  (parent 58)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d)))))
  (label 195)
  (parent 58)
  (seen 227)
  (unrealized (0 1) (4 0) (6 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 196)
  (parent 58)
  (seen 215 218)
  (unrealized (0 1) (4 0) (6 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-2 nb-1)) na (2 0)
    (enc a b c na nb-0 nc-1 (pubk d)) (enc a b d na nb-0 (pubk c))
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 197)
  (parent 59)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-2 nb-0)) na (2 0)
    (enc a b c na nb-0 nc-1 (pubk d)) (enc a b d na nb-0 (pubk c))
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 198)
  (parent 59)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (2 0)
    (enc a b c na nb-1 nc-1 (pubk d)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 199)
  (parent 59)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (2 0)
    (enc a b c na nb-1 nc-1 (pubk d)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 200)
  (parent 59)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (2 0)
    (enc a b c na nb-1 nc-1 (pubk d)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 201)
  (parent 59)
  (unrealized (0 1) (2 0) (6 0))
  (comment "8 in cohort - 8 not yet seen"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (2 0)
    (enc a b c na nb-1 nc-1 (pubk d)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 202)
  (parent 59)
  (unrealized (0 1) (2 0) (6 0))
  (comment "8 in cohort - 8 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-2 nb-1)) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 203)
  (parent 60)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-2 nb-0)) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 204)
  (parent 60)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 205)
  (parent 60)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-2 (4 0)
    (enc a b d nb-2 nb-2 (pubk c)) (enc a b d nb-2 nb-1 (pubk c))
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 206)
  (parent 60)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 207)
  (parent 60)
  (seen 218)
  (unrealized (0 1) (4 0) (6 0))
  (comment "7 in cohort - 5 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 208)
  (parent 60)
  (seen 252 684 734)
  (unrealized (0 1) (4 0) (6 0))
  (comment "7 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-2 nb-1)) nb-0 (2 0)
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 209)
  (parent 61)
  (unrealized (0 1))
  (comment "2 in cohort - 2 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-2 nb-0)) nb-0 (2 0)
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 210)
  (parent 61)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 1 resp1 2) nb-1 (2 0)
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a b d nb-1 nb-2 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 211)
  (parent 61)
  (unrealized (0 1))
  (comment "3 in cohort - 3 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp2 2) nb-1 (2 0)
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a b d nb-1 nb-2 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d)))))
  (label 212)
  (parent 61)
  (seen 708)
  (unrealized (0 1) (2 0) (6 0))
  (comment "8 in cohort - 6 not yet seen"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (2 0)
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a b d nb-1 nb-2 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 213)
  (parent 61)
  (seen 716)
  (unrealized (0 1) (2 0) (6 0))
  (comment "8 in cohort - 6 not yet seen"))

(comment "Strand bound exceeded--aborting run")

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 nb-3 text)
    (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-3) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (4 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-3 (pubk c)))))
  (label 214)
  (parent 62)
  (unrealized (0 1) (2 0) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 215)
  (parent 62)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 216)
  (parent 62)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 217)
  (parent 62)
  (unrealized (0 1) (2 0) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 218)
  (parent 62)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d)))))
  (label 219)
  (parent 62)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-2) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-2)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-2 (pubk b)))
      (recv (enc b c d nb-2 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-0 (pubk c))))
    ((recv (enc a b d nb-2 nb-0 (pubk c)))
      (send (enc a b c nb-2 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-1 (pubk c))))
    ((recv (enc a b d nb-2 nb-1 (pubk c)))
      (send (enc a b c nb-2 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-2 (pubk c))))
    ((recv (enc a b d nb-2 nb-2 (pubk c)))
      (send (enc a b c nb-2 nb-2 nc-2 (pubk d)))))
  (label 220)
  (parent 62)
  (unrealized (0 1) (2 0) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 221)
  (parent 63)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-1 (pubk d)))
      (send (enc b c d na nb-0 nc-1 nd-0 (pubk a)))))
  (label 222)
  (parent 63)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 223)
  (parent 64)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 224)
  (parent 64)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 225)
  (parent 65)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 226)
  (parent 65)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 227)
  (parent 66)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (5 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d)))))
  (label 228)
  (parent 66)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (5 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d)))))
  (label 229)
  (parent 66)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (5 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 230)
  (parent 66)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (5 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-2 (pubk d)))))
  (label 231)
  (parent 66)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 232)
  (parent 67)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-1 (pubk d)))
      (send (enc b c d na nb-0 nc-1 nd-0 (pubk a)))))
  (label 233)
  (parent 67)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 234)
  (parent 68)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 235)
  (parent 68)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 236)
  (parent 69)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 237)
  (parent 69)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 238)
  (parent 70)
  (unrealized (0 1) (2 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (5 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 239)
  (parent 70)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (4 0)) ((3 1) (5 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 240)
  (parent 70)
  (unrealized (0 1) (2 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (5 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 241)
  (parent 70)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (4 0)) ((3 1) (5 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 242)
  (parent 70)
  (unrealized (0 1) (2 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (5 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 6 4 resp2 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-1 (pubk c))))
    ((recv (enc a b d nc-1 nb-1 (pubk c)))
      (send (enc a b c nc-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nc-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 243)
  (parent 70)
  (unrealized (0 1) (2 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 244)
  (parent 71)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 245)
  (parent 71)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 246)
  (parent 71)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 247)
  (parent 72)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 248)
  (parent 72)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 249)
  (parent 73)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 250)
  (parent 73)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 251)
  (parent 73)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 252)
  (parent 74)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (5 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 253)
  (parent 74)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (5 0)) ((4 1) (2 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 254)
  (parent 74)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 255)
  (parent 75)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 256)
  (parent 75)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 257)
  (parent 75)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-2 nb-1)) nb-0 (2 0)
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 258)
  (parent 76)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-2 nb-0)) nb-0 (2 0)
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 259)
  (parent 76)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 1 resp1 2) nb-1 (2 0)
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a b d nb-1 nb-2 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 260)
  (parent 76)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) nb-2 (2 0)
    (enc a b c nb-2 nb-2 nc-1 (pubk d)) (enc a b d nb-2 nb-2 (pubk c))
    (enc a b d nb-2 nb-1 (pubk c)) (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 261)
  (parent 76)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (2 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp2 2) nb-1 (2 0)
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a b d nb-1 nb-2 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d)))))
  (label 262)
  (parent 76)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (2 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (2 0)
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a b d nb-1 nb-2 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 263)
  (parent 76)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 264)
  (parent 77)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 265)
  (parent 77)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 266)
  (parent 78)
  (unrealized (0 1) (2 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (5 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 1 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 267)
  (parent 78)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (5 0)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 268)
  (parent 78)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nc-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nc-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-1) (nb nc-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (4 0)) ((4 1) (5 0)) ((5 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 6 4 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nc-1 (pubk c))))
    ((recv (enc a b d nc-1 nc-1 (pubk c)))
      (send (enc a b c nc-1 nc-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-1 nc-1 nc-1 (pubk d)))
      (send (enc b c d nc-1 nc-1 nc-1 nd-0 (pubk a)))))
  (label 269)
  (parent 78)
  (unrealized (0 1) (2 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (3 0)) ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0))
    ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (3 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 270)
  (parent 79)
  (unrealized (0 1) (3 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 2 resp2 2) na (3 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 271)
  (parent 79)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (3 0)) ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0))
    ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (3 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 272)
  (parent 79)
  (unrealized (0 1) (3 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (3 0)) ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0))
    ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (3 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 273)
  (parent 80)
  (unrealized (0 1) (3 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (3 0)) ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0))
    ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (3 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 274)
  (parent 80)
  (unrealized (0 1) (3 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-0 (3 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 275)
  (parent 80)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (3 0))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 276)
  (parent 81)
  (unrealized (0 1) (3 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 277)
  (parent 81)
  (unrealized (0 1) (3 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (0 1)) ((4 1) (5 0)) ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 4 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 278)
  (parent 81)
  (unrealized (0 1) (3 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 279)
  (parent 81)
  (unrealized (0 1) (3 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (0 1)) ((4 1) (5 0)) ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 4 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 280)
  (parent 81)
  (unrealized (0 1) (3 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d)))))
  (label 281)
  (parent 81)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) na
    (0 1) (enc a b c na nb nc (pubk d)) (enc a b d na nb (pubk c))
    (enc a c d na (pubk b)) (enc b c d na nb nc nd (pubk a)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c))))
    ((recv (enc a b d na nb (pubk c)))
      (send (enc a b c na nb nc (pubk d))))
    ((recv (enc a b c na nb nc (pubk d)))
      (send (enc b c d na nb nc nd (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c)))))
  (label 282)
  (parent 82)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 text) (a b c d name))
  (defstrand init 3 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-1 nb) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nb nc (pubk d)) (enc a b d nc nb (pubk c))
    (enc a b d nc nb-0 (pubk c)) (enc a c d nc (pubk b))
    (enc b c d nc nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b d nc nb (pubk c)))
      (send (enc a b c nc nb nc (pubk d))))
    ((recv (enc a b c nc nb nc (pubk d)))
      (send (enc b c d nc nb nc nd (pubk a))))
    ((recv (enc a c d nc (pubk b)))
      (send (enc a b d nc nb-0 (pubk c)))))
  (label 283)
  (parent 83)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (3 0)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 284)
  (parent 83)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (3 0)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d)))))
  (label 285)
  (parent 83)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (5 0)) ((1 1) (2 0)) ((1 1) (3 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 286)
  (parent 84)
  (unrealized (0 1) (3 0) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 5 1 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 287)
  (parent 84)
  (unrealized (0 1) (3 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 1 resp1 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 288)
  (parent 84)
  (unrealized (0 1) (3 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (0 1))
    ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) na (4 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 289)
  (parent 84)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) na
    (0 1) (enc a b c na nb nc (pubk d)) (enc a b d na nb (pubk c))
    (enc a c d na (pubk b)) (enc b c d na nb nc nd (pubk a)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c))))
    ((recv (enc a b d na nb (pubk c)))
      (send (enc a b c na nb nc (pubk d))))
    ((recv (enc a b c na nb nc (pubk d)))
      (send (enc b c d na nb nc nd (pubk a)))))
  (label 290)
  (parent 85)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (5 0)) ((1 1) (2 0)) ((1 1) (3 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (4 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 291)
  (parent 86)
  (unrealized (0 1) (3 0) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (0 1))
    ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nb-0 (4 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 292)
  (parent 86)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd text) (a b c d name))
  (defstrand init 3 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((3 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) nb
    (0 1) (enc a b c nb nb nc (pubk d)) (enc a b d nb nb (pubk c))
    (enc a c d nb (pubk b)) (enc b c d nb nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nb (pubk b)))
      (recv (enc b c d nb nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb (pubk c))))
    ((recv (enc a b d nb nb (pubk c)))
      (send (enc a b c nb nb nc (pubk d))))
    ((recv (enc a b c nb nb nc (pubk d)))
      (send (enc b c d nb nb nc nd (pubk a)))))
  (label 293)
  (parent 87)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)) (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 294)
  (parent 87)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (5 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (4 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 295)
  (parent 89)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 1 resp1 2) nc-0 (4 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 296)
  (parent 89)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nb-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 1 resp1 2) nc-1 (4 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nb-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nb-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d)))))
  (label 297)
  (parent 89)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((2 1) (4 0))
    ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nc-0 (4 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 298)
  (parent 89)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nd-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nb-0) (nc nd-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nd-0) (nb nb-0) (nc nd-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((3 1) (4 0))
    ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nd-0)
  (operation nonce-test (displaced 5 3 resp3 2) nc-1 (4 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nd-0 (pubk b)))
      (recv (enc b c d nd-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nb-0 (pubk c))))
    ((recv (enc a b d nd-0 nb-0 (pubk c)))
      (send (enc a b c nd-0 nb-0 nd-0 (pubk d))))
    ((recv (enc a b c nd-0 nb-0 nd-0 (pubk d)))
      (send (enc b c d nd-0 nb-0 nd-0 nd-0 (pubk a))))
    ((recv (enc a b d nd-0 nb-0 (pubk c)))
      (send (enc a b c nd-0 nb-0 nc-0 (pubk d)))))
  (label 299)
  (parent 89)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-2 nb-1)) nb-0 (4 0)
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 300)
  (parent 90)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) nb-0 (4 0)
    (enc a b d nb-0 nb-2 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 301)
  (parent 90)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-0 (4 0)
    (enc a b d nb-0 nb-2 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 302)
  (parent 90)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-2 (4 0)
    (enc a b d nb-2 nb-1 (pubk c)) (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 303)
  (parent 90)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-2 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 304)
  (parent 90)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (0 1)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-2 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c)))))
  (label 305)
  (parent 90)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (0 1)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-2 (4 0)
    (enc a b d nb-2 nb-1 (pubk c)) (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 306)
  (parent 90)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-1 nb-0)) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 307)
  (parent 91)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 308)
  (parent 91)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 309)
  (parent 92)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 310)
  (parent 92)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 311)
  (parent 93)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 312)
  (parent 93)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (contracted (nb-0 nc-0)) nc-0 (4 0)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 313)
  (parent 94)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 3 resp1 2) nc-0 (4 0)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 314)
  (parent 94)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (4 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 5 3 resp1 2) nc-1 (4 0)
    (enc a b c nc-1 nc-1 nc-1 (pubk d)) (enc a b d nc-1 nc-1 (pubk c))
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d)))))
  (label 315)
  (parent 94)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (0 1)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (4 0)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-2 (pubk d)))))
  (label 316)
  (parent 94)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (0 1)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp3 2) nc-0 (4 0)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 317)
  (parent 94)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 318)
  (parent 95)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nc nb nd text) (a b c d name))
  (defstrand init 3 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nc) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-0 nc) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nc nc (pubk d)) (enc a b d nc nc (pubk c))
    (enc a b d nc nb (pubk c)) (enc a c d nc (pubk b))
    (enc b c d nc nc nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nc nc nd (pubk a)))
      (send (enc nc nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b d nc nc (pubk c)))
      (send (enc a b c nc nc nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b c nc nc nc (pubk d)))
      (send (enc b c d nc nc nc nd (pubk a)))))
  (label 319)
  (parent 96)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (0 1)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 320)
  (parent 96)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (0 1)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 321)
  (parent 96)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (3 0))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 322)
  (parent 97)
  (unrealized (0 1) (3 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (0 1)) ((4 1) (5 0)) ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 4 resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 323)
  (parent 97)
  (unrealized (0 1) (3 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (0 1)) ((4 1) (5 0)) ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 4 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 324)
  (parent 97)
  (unrealized (0 1) (3 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 325)
  (parent 97)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd text) (a b c d name))
  (defstrand init 3 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb) (nb nb) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) nb
    (0 1) (enc a b c nb nb nc (pubk d)) (enc a b d nb nb (pubk c))
    (enc a c d nb (pubk b)) (enc b c d nb nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nb (pubk b)))
      (recv (enc b c d nb nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb (pubk c))))
    ((recv (enc a b d nb nb (pubk c)))
      (send (enc a b c nb nb nc (pubk d))))
    ((recv (enc a b c nb nb nc (pubk d)))
      (send (enc b c d nb nb nc nd (pubk a))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb (pubk c)))))
  (label 326)
  (parent 98)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (3 0)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)) (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 327)
  (parent 98)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nc nd nb text) (a b c d name))
  (defstrand init 3 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nc) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (3 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-0 nc) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nc nc (pubk d)) (enc a b d nc nc (pubk c))
    (enc a b d nc nb (pubk c)) (enc a c d nc (pubk b))
    (enc b c d nc nc nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nc nc nd (pubk a)))
      (send (enc nc nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b d nc nc (pubk c)))
      (send (enc a b c nc nc nc (pubk d))))
    ((recv (enc a b c nc nc nc (pubk d)))
      (send (enc b c d nc nc nc nd (pubk a))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c)))))
  (label 328)
  (parent 99)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (3 0)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 329)
  (parent 99)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nb-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (4 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (3 0)) ((3 1) (0 1)) ((4 1) (3 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 330)
  (parent 99)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nc-1 nb-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (5 0)) ((1 1) (2 0)) ((2 1) (3 0))
    ((3 1) (0 1)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (4 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c)))))
  (label 331)
  (parent 101)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((2 1) (4 0))
    ((3 1) (0 1)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 5 2 resp2 2) nc-0 (4 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 332)
  (parent 101)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nd-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nd-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nd-0) (nc nd-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nd-0) (nb nd-0) (nc nd-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nd-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((1 1) (2 0)) ((2 1) (3 0)) ((3 1) (4 0))
    ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nd-0)
  (operation nonce-test (displaced 5 3 resp3 2) nc-1 (4 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nd-0 (pubk b)))
      (recv (enc b c d nd-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nd-0 (pubk c))))
    ((recv (enc a b d nd-0 nd-0 (pubk c)))
      (send (enc a b c nd-0 nd-0 nd-0 (pubk d))))
    ((recv (enc a b c nd-0 nd-0 nd-0 (pubk d)))
      (send (enc b c d nd-0 nd-0 nd-0 nd-0 (pubk a))))
    ((recv (enc a b d nd-0 nd-0 (pubk c)))
      (send (enc a b c nd-0 nd-0 nc-0 (pubk d)))))
  (label 333)
  (parent 101)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 334)
  (parent 102)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 335)
  (parent 102)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 336)
  (parent 102)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-0 (pubk c)))))
  (label 337)
  (parent 102)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 338)
  (parent 102)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 339)
  (parent 103)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 340)
  (parent 103)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 341)
  (parent 103)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 342)
  (parent 104)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c)))))
  (label 343)
  (parent 104)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 344)
  (parent 104)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 345)
  (parent 104)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nb-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c)))))
  (label 346)
  (parent 104)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 347)
  (parent 105)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c)))))
  (label 348)
  (parent 105)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 349)
  (parent 105)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 350)
  (parent 105)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nb-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c)))))
  (label 351)
  (parent 105)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 352)
  (parent 106)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 353)
  (parent 106)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (6 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 354)
  (parent 106)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 355)
  (parent 106)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 356)
  (parent 106)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (6 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 357)
  (parent 106)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 358)
  (parent 106)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (6 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 7 2 resp2 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d)))))
  (label 359)
  (parent 106)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nc nb nd text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) na
    (0 1) (enc a b c na nb nc (pubk d)) (enc a b d na nb (pubk c))
    (enc a c d na (pubk b)) (enc b c d na nb nc nd (pubk a)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c))))
    ((recv (enc a b d na nb (pubk c)))
      (send (enc a b c na nb nc (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c))))
    ((recv (enc a b c na nb nc (pubk d)))
      (send (enc b c d na nb nc nd (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c)))))
  (label 360)
  (parent 107)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nc nb nd nb-0 text) (a b c d name))
  (defstrand init 3 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-1 nb) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nb nc (pubk d)) (enc a b d nc nb (pubk c))
    (enc a b d nc nb-0 (pubk c)) (enc a c d nc (pubk b))
    (enc b c d nc nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b d nc nb (pubk c)))
      (send (enc a b c nc nb nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b c nc nb nc (pubk d)))
      (send (enc b c d nc nb nc nd (pubk a))))
    ((recv (enc a c d nc (pubk b)))
      (send (enc a b d nc nb-0 (pubk c)))))
  (label 361)
  (parent 108)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 362)
  (parent 108)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d)))))
  (label 363)
  (parent 108)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 364)
  (parent 109)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (5 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 365)
  (parent 109)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 366)
  (parent 109)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 367)
  (parent 109)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 368)
  (parent 109)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nc nb nd text) (a b c d name))
  (defstrand init 3 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nb nc (pubk d)) (enc a b d nc nb (pubk c))
    (enc a c d nc (pubk b)) (enc b c d nc nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b d nc nb (pubk c)))
      (send (enc a b c nc nb nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b c nc nb nc (pubk d)))
      (send (enc b c d nc nb nc nd (pubk a)))))
  (label 369)
  (parent 110)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 370)
  (parent 110)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 371)
  (parent 111)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (5 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 372)
  (parent 111)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 373)
  (parent 111)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (5 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 374)
  (parent 111)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 375)
  (parent 111)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 376)
  (parent 111)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nc nb nd text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) na
    (0 1) (enc a b c na nb nc (pubk d)) (enc a b d na nb (pubk c))
    (enc a c d na (pubk b)) (enc b c d na nb nc nd (pubk a)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c))))
    ((recv (enc a b d na nb (pubk c)))
      (send (enc a b c na nb nc (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c))))
    ((recv (enc a b c na nb nc (pubk d)))
      (send (enc b c d na nb nc nd (pubk a)))))
  (label 377)
  (parent 112)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 378)
  (parent 113)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 379)
  (parent 113)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nc nd text) (a b c d name))
  (defstrand init 3 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nc) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (4 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb nc) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nc nc (pubk d)) (enc a b d nc nc (pubk c))
    (enc a c d nc (pubk b)) (enc b c d nc nc nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nc nc nd (pubk a)))
      (send (enc nc nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b d nc nc (pubk c)))
      (send (enc a b c nc nc nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b c nc nc nc (pubk d)))
      (send (enc b c d nc nc nc nd (pubk a)))))
  (label 380)
  (parent 114)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nb-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c)))))
  (label 381)
  (parent 114)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 382)
  (parent 114)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 383)
  (parent 115)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 384)
  (parent 115)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nc nb nd text) (a b c d name))
  (defstrand init 3 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nb) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) nb
    (0 1) (enc a b c nb nb nc (pubk d)) (enc a b d nb nb (pubk c))
    (enc a c d nb (pubk b)) (enc b c d nb nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nb (pubk b)))
      (recv (enc b c d nb nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb (pubk c))))
    ((recv (enc a b d nb nb (pubk c)))
      (send (enc a b c nb nb nc (pubk d))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb (pubk c))))
    ((recv (enc a b c nb nb nc (pubk d)))
      (send (enc b c d nb nb nc nd (pubk a)))))
  (label 385)
  (parent 116)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)) (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 386)
  (parent 116)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nc nd text) (a b c d name))
  (defstrand init 3 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nc) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb nc) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nc nc (pubk d)) (enc a b d nc nc (pubk c))
    (enc a c d nc (pubk b)) (enc b c d nc nc nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nc nc nd (pubk a)))
      (send (enc nc nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b d nc nc (pubk c)))
      (send (enc a b c nc nc nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b c nc nc nc (pubk d)))
      (send (enc b c d nc nc nc nd (pubk a)))))
  (label 387)
  (parent 117)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nb-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c)))))
  (label 388)
  (parent 117)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 389)
  (parent 117)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (0 1))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 390)
  (parent 119)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (5 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 391)
  (parent 119)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 392)
  (parent 119)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nb-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (5 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nb-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nb-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d)))))
  (label 393)
  (parent 119)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nb-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nb-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nb-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d)))))
  (label 394)
  (parent 119)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((2 1) (5 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 395)
  (parent 119)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nd-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nb-0) (nc nd-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nd-0) (nb nb-0) (nc nd-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (0 1)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nd-0)
  (operation nonce-test (displaced 6 4 resp3 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nd-0 (pubk b)))
      (recv (enc b c d nd-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nb-0 (pubk c))))
    ((recv (enc a b d nd-0 nb-0 (pubk c)))
      (send (enc a b c nd-0 nb-0 nd-0 (pubk d))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nb-0 (pubk c))))
    ((recv (enc a b c nd-0 nb-0 nd-0 (pubk d)))
      (send (enc b c d nd-0 nb-0 nd-0 nd-0 (pubk a))))
    ((recv (enc a b d nd-0 nb-0 (pubk c)))
      (send (enc a b c nd-0 nb-0 nc-0 (pubk d)))))
  (label 396)
  (parent 119)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 397)
  (parent 120)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 398)
  (parent 120)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-2 nb-1)) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 399)
  (parent 121)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-2 nb-0)) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 400)
  (parent 121)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 401)
  (parent 121)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 402)
  (parent 121)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d)))))
  (label 403)
  (parent 121)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 404)
  (parent 121)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 405)
  (parent 121)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 406)
  (parent 122)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 407)
  (parent 122)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 408)
  (parent 122)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (contracted (nb-2 nb-1)) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 409)
  (parent 123)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 410)
  (parent 123)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-2 (4 0)
    (enc a b d nb-2 nb-2 (pubk c)) (enc a b d nb-2 nb-1 (pubk c))
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 411)
  (parent 123)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 412)
  (parent 123)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 413)
  (parent 123)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 414)
  (parent 123)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp2 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d)))))
  (label 415)
  (parent 124)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 416)
  (parent 124)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 417)
  (parent 124)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 nb-3 text)
    (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-3) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-3 (pubk c)))))
  (label 418)
  (parent 125)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (6 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 419)
  (parent 125)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (6 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 420)
  (parent 125)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 421)
  (parent 125)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (6 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 422)
  (parent 125)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (6 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d)))))
  (label 423)
  (parent 125)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-2) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-2)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-2 (pubk b)))
      (recv (enc b c d nb-2 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-0 (pubk c))))
    ((recv (enc a b d nb-2 nb-0 (pubk c)))
      (send (enc a b c nb-2 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-1 (pubk c))))
    ((recv (enc a b d nb-2 nb-1 (pubk c)))
      (send (enc a b c nb-2 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-2 (pubk c))))
    ((recv (enc a b d nb-2 nb-2 (pubk c)))
      (send (enc a b c nb-2 nb-2 nc-2 (pubk d)))))
  (label 424)
  (parent 125)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (6 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 7 2 resp2 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c))))
    ((recv (enc a b d nc-0 nb-2 (pubk c)))
      (send (enc a b c nc-0 nb-2 nc-2 (pubk d)))))
  (label 425)
  (parent 125)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 426)
  (parent 126)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 427)
  (parent 126)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-1 nc-1 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a b d nc-0 nb-2 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-2 (pubk d)))))
  (label 428)
  (parent 127)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-1 nc-1 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a b d nc-0 nb-2 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c))))
    ((recv (enc a b d nc-0 nb-2 (pubk c)))
      (send (enc a b c nc-0 nb-2 nc-2 (pubk d)))))
  (label 429)
  (parent 127)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp3 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-1 nc-1 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a b d nc-0 nb-2 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c))))
    ((recv (enc a b c nc-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 430)
  (parent 127)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp3 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-1 nc-1 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a b d nc-0 nb-2 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 431)
  (parent 127)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 432)
  (parent 128)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-1 (pubk d)))
      (send (enc b c d na nb-0 nc-1 nd-0 (pubk a)))))
  (label 433)
  (parent 128)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 434)
  (parent 129)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 435)
  (parent 130)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 436)
  (parent 130)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 437)
  (parent 131)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d)))))
  (label 438)
  (parent 131)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d)))))
  (label 439)
  (parent 131)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 440)
  (parent 131)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-2 (pubk d)))))
  (label 441)
  (parent 131)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-2 (pubk d)))))
  (label 442)
  (parent 131)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 443)
  (parent 132)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 444)
  (parent 132)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 445)
  (parent 132)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 446)
  (parent 132)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 447)
  (parent 132)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 448)
  (parent 132)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 6 4 resp2 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-1 (pubk c))))
    ((recv (enc a b d nc-1 nb-1 (pubk c)))
      (send (enc a b c nc-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 449)
  (parent 132)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 450)
  (parent 133)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 451)
  (parent 133)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 452)
  (parent 133)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 453)
  (parent 133)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 454)
  (parent 133)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 455)
  (parent 133)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 6 4 resp2 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-1 (pubk c))))
    ((recv (enc a b d nc-1 nb-1 (pubk c)))
      (send (enc a b c nc-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nc-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 456)
  (parent 133)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 457)
  (parent 134)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 458)
  (parent 134)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 459)
  (parent 135)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 460)
  (parent 135)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 461)
  (parent 135)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-2 (pubk d)))))
  (label 462)
  (parent 135)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 463)
  (parent 136)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 1 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 464)
  (parent 136)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 465)
  (parent 136)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 466)
  (parent 136)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nc-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nc-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 6 4 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nc-1 (pubk c))))
    ((recv (enc a b d nc-1 nc-1 (pubk c)))
      (send (enc a b c nc-1 nc-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 467)
  (parent 136)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 468)
  (parent 137)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 1 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 469)
  (parent 137)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 470)
  (parent 137)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-1 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-1 nd-0 (pubk a)))))
  (label 471)
  (parent 137)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nc-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nc-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-1) (nb nc-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 6 4 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nc-1 (pubk c))))
    ((recv (enc a b d nc-1 nc-1 (pubk c)))
      (send (enc a b c nc-1 nc-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-1 nc-1 nc-1 (pubk d)))
      (send (enc b c d nc-1 nc-1 nc-1 nd-0 (pubk a)))))
  (label 472)
  (parent 137)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 nb-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-2 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c)))))
  (label 473)
  (parent 138)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-2 (pubk d)))))
  (label 474)
  (parent 138)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-2 (pubk d)))))
  (label 475)
  (parent 138)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nc-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-2 (5 0)
    (enc a c d nc-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-0 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 476)
  (parent 138)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nc-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nb-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) nc-2 (5 0)
    (enc a c d nc-2 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nb-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-0 (pubk d))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-1 (pubk d)))))
  (label 477)
  (parent 138)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((2 1) (5 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-2 (pubk d)))))
  (label 478)
  (parent 138)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nc-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 4 resp2 2) nc-2 (5 0)
    (enc a c d nc-2 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-0 (pubk d))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 479)
  (parent 138)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-1 nc-1 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c)))))
  (label 480)
  (parent 139)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 481)
  (parent 139)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 482)
  (parent 139)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-1 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-0 nd-0 (pubk a)))))
  (label 483)
  (parent 139)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nb-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nb-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-0 (pubk d))))
    ((recv (enc a b c nb-1 nb-1 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-0 nd-0 (pubk a)))))
  (label 484)
  (parent 139)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((2 1) (5 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 485)
  (parent 139)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-1) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 4 resp2 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-1 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-1 nc-0 nd-0 (pubk a)))))
  (label 486)
  (parent 139)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c)))))
  (label 487)
  (parent 140)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 488)
  (parent 140)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 489)
  (parent 140)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nb-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nb-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nb-0 nd-0 (pubk a)))))
  (label 490)
  (parent 140)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nb-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nb-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nb-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-0 (pubk d))))
    ((recv (enc a b c nb-1 nb-0 nb-1 (pubk d)))
      (send (enc b c d nb-1 nb-0 nb-1 nd-0 (pubk a)))))
  (label 491)
  (parent 140)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((2 1) (5 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 492)
  (parent 140)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 4 resp2 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 493)
  (parent 140)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 494)
  (parent 141)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 495)
  (parent 141)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 496)
  (parent 141)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 497)
  (parent 141)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-1 (pubk d)))))
  (label 498)
  (parent 141)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 499)
  (parent 142)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 500)
  (parent 142)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 2 resp2 2) na (4 0)
    (enc a b d na nb-2 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-1 (pubk c)))))
  (label 501)
  (parent 142)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-1 (pubk c)) (enc a b d na nb-2 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-1 (pubk d)))))
  (label 502)
  (parent 142)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-1 (pubk d)))))
  (label 503)
  (parent 143)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 504)
  (parent 143)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 505)
  (parent 143)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-1 (pubk d)))))
  (label 506)
  (parent 144)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c)))))
  (label 507)
  (parent 144)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 508)
  (parent 144)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-2 (4 0)
    (enc a b d nb-2 nb-2 (pubk c)) (enc a b d nb-2 nb-1 (pubk c))
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 509)
  (parent 144)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-2 (4 0)
    (enc a b d nb-2 nb-2 (pubk c)) (enc a b d nb-2 nb-1 (pubk c))
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 510)
  (parent 144)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 nb-3 text)
    (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-3) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-3 (pubk c)))))
  (label 511)
  (parent 145)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (6 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-1 (pubk d)))))
  (label 512)
  (parent 145)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (6 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-1 (pubk d)))))
  (label 513)
  (parent 145)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-1 (pubk d)))))
  (label 514)
  (parent 145)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (6 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-1 (pubk d)))))
  (label 515)
  (parent 145)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (6 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-1 (pubk d)))))
  (label 516)
  (parent 145)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-2) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-2) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-2)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-2 (pubk b)))
      (recv (enc b c d nb-2 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-0 (pubk c))))
    ((recv (enc a b d nb-2 nb-0 (pubk c)))
      (send (enc a b c nb-2 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-1 (pubk c))))
    ((recv (enc a b c nb-2 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-2 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-2 (pubk c))))
    ((recv (enc a b d nb-2 nb-2 (pubk c)))
      (send (enc a b c nb-2 nb-2 nc-1 (pubk d)))))
  (label 517)
  (parent 145)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (6 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 7 2 resp2 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c))))
    ((recv (enc a b d nc-0 nb-2 (pubk c)))
      (send (enc a b c nc-0 nb-2 nc-1 (pubk d)))))
  (label 518)
  (parent 145)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nb-0 nd text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-1 nb) (nc-0 nc) (nd-0 nd)) na
    (0 1) (enc a b c na nb nc (pubk d)) (enc a b d na nb (pubk c))
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b))
    (enc b c d na nb nc nd (pubk a)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c))))
    ((recv (enc a b d na nb (pubk c)))
      (send (enc a b c na nb nc (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb nc (pubk d)))
      (send (enc b c d na nb nc nd (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c)))))
  (label 519)
  (parent 146)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b d na nb-0 (pubk c))
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b))
    (enc b c d na nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 520)
  (parent 146)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nb-0 nd nb-1 text) (a b c d name))
  (defstrand init 3 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-2 nb) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nb nc (pubk d)) (enc a b d nc nb (pubk c))
    (enc a b d nc nb-0 (pubk c)) (enc a b d nc nb-1 (pubk c))
    (enc a c d nc (pubk b)) (enc b c d nc nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b d nc nb (pubk c)))
      (send (enc a b c nc nb nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb-0 (pubk c))))
    ((recv (enc a b c nc nb nc (pubk d)))
      (send (enc b c d nc nb nc nd (pubk a))))
    ((recv (enc a c d nc (pubk b)))
      (send (enc a b d nc nb-1 (pubk c)))))
  (label 521)
  (parent 147)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a b d nc-0 nb-2 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 522)
  (parent 147)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a b d nc-0 nb-2 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d)))))
  (label 523)
  (parent 147)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nb-1 (pubk c)) (enc a b d nc-0 nb-2 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c))))
    ((recv (enc a b d nc-0 nb-2 (pubk c)))
      (send (enc a b c nc-0 nb-2 nc-1 (pubk d)))))
  (label 524)
  (parent 147)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 525)
  (parent 148)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (4 0)
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 526)
  (parent 148)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-0 (pubk c)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-1 (pubk d)))))
  (label 527)
  (parent 149)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 5 2 resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-0 (pubk c)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 528)
  (parent 149)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-0 (pubk c)) (enc a b d nb-1 nb-1 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 529)
  (parent 149)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 530)
  (parent 150)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 531)
  (parent 150)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d)))))
  (label 532)
  (parent 150)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 533)
  (parent 150)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-1 (pubk d)))))
  (label 534)
  (parent 150)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 535)
  (parent 150)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nb-0 nd text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-1 nb) (nc-0 nc) (nd-0 nd)) na
    (0 1) (enc a b c na nb nc (pubk d)) (enc a b d na nb (pubk c))
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b))
    (enc b c d na nb nc nd (pubk a)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c))))
    ((recv (enc a b d na nb (pubk c)))
      (send (enc a b c na nb nc (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb nc (pubk d)))
      (send (enc b c d na nb nc nd (pubk a)))))
  (label 536)
  (parent 151)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b d na nb-0 (pubk c))
    (enc a b d na nb-1 (pubk c)) (enc a c d na (pubk b))
    (enc b c d na nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 537)
  (parent 151)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 538)
  (parent 152)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 539)
  (parent 152)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 540)
  (parent 153)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 541)
  (parent 153)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d)))))
  (label 542)
  (parent 153)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 543)
  (parent 153)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 544)
  (parent 153)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) na (5 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d)))))
  (label 545)
  (parent 153)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) na
    (0 1) (enc a b c na nb nc (pubk d)) (enc a b d na nb (pubk c))
    (enc a c d na (pubk b)) (enc b c d na nb nc nd (pubk a)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c))))
    ((recv (enc a b d na nb (pubk c)))
      (send (enc a b c na nb nc (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb (pubk c))))
    ((recv (enc a b c na nb nc (pubk d)))
      (send (enc b c d na nb nc nd (pubk a)))))
  (label 546)
  (parent 154)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 547)
  (parent 155)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 548)
  (parent 155)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 549)
  (parent 155)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 550)
  (parent 155)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nb-0 nd text) (a b c d name))
  (defstrand init 3 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nb) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb)
  (operation nonce-test (contracted (nb-1 nb) (nc-0 nc) (nd-0 nd)) nb
    (0 1) (enc a b c nb nb nc (pubk d)) (enc a b d nb nb (pubk c))
    (enc a b d nb nb-0 (pubk c)) (enc a c d nb (pubk b))
    (enc b c d nb nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nb (pubk b)))
      (recv (enc b c d nb nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb (pubk c))))
    ((recv (enc a b d nb nb (pubk c)))
      (send (enc a b c nb nb nc (pubk d))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb-0 (pubk c))))
    ((recv (enc a b c nb nb nc (pubk d)))
      (send (enc b c d nb nb nc nd (pubk a)))))
  (label 551)
  (parent 156)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b))
    (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 552)
  (parent 156)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c)))))
  (label 553)
  (parent 157)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 1 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 554)
  (parent 157)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 555)
  (parent 157)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd text) (a b c d name))
  (defstrand init 3 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nb) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) nb
    (0 1) (enc a b c nb nb nc (pubk d)) (enc a b d nb nb (pubk c))
    (enc a c d nb (pubk b)) (enc b c d nb nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nb (pubk b)))
      (recv (enc b c d nb nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb (pubk c))))
    ((recv (enc a b d nb nb (pubk c)))
      (send (enc a b c nb nb nc (pubk d))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb (pubk c))))
    ((recv (enc a b c nb nb nc (pubk d)))
      (send (enc b c d nb nb nc nd (pubk a)))))
  (label 556)
  (parent 158)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a c d nb-0 (pubk b)) (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 557)
  (parent 158)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd text) (a b c d name))
  (defstrand init 3 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-0 nb) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nb nc (pubk d)) (enc a b d nc nb (pubk c))
    (enc a b d nc nc (pubk c)) (enc a c d nc (pubk b))
    (enc b c d nc nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b d nc nb (pubk c)))
      (send (enc a b c nc nb nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b c nc nb nc (pubk d)))
      (send (enc b c d nc nb nc nd (pubk a)))))
  (label 558)
  (parent 159)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nc-0 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 559)
  (parent 159)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nb-0 nc-0 (pubk d)) (enc a b d nc-0 nb-0 (pubk c))
    (enc a b d nc-0 nc-0 (pubk c)) (enc a c d nc-0 (pubk b))
    (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 560)
  (parent 159)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c)))))
  (label 561)
  (parent 161)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 562)
  (parent 161)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 563)
  (parent 161)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nb-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nb-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nb-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d)))))
  (label 564)
  (parent 161)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nb-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nb-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 6 3 resp1 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nb-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nb-1 (pubk d)))
      (send (enc b c d nb-1 nb-0 nb-1 nd-0 (pubk a))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d)))))
  (label 565)
  (parent 161)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((2 1) (5 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 566)
  (parent 161)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nd-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nb-0) (nc nd-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nd-0) (nb nb-0) (nc nd-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nd-0)
  (operation nonce-test (displaced 6 4 resp3 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nd-0 (pubk b)))
      (recv (enc b c d nd-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nb-0 (pubk c))))
    ((recv (enc a b d nd-0 nb-0 (pubk c)))
      (send (enc a b c nd-0 nb-0 nd-0 (pubk d))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nb-1 (pubk c))))
    ((recv (enc a b c nd-0 nb-0 nd-0 (pubk d)))
      (send (enc b c d nd-0 nb-0 nd-0 nd-0 (pubk a))))
    ((recv (enc a b d nd-0 nb-0 (pubk c)))
      (send (enc a b c nd-0 nb-0 nc-0 (pubk d)))))
  (label 567)
  (parent 161)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-2 (pubk c)))))
  (label 568)
  (parent 162)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d)))))
  (label 569)
  (parent 162)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nb-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((1 1) (5 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 1 resp1 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nb-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nb-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-0 (pubk d)))))
  (label 570)
  (parent 162)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nb-1 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nd-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nb-0) (nc nd-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nd-0) (nb nb-0) (nc nd-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nd-0)
  (operation nonce-test (displaced 6 4 resp3 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nd-0 (pubk b)))
      (recv (enc b c d nd-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nb-0 (pubk c))))
    ((recv (enc a b d nd-0 nb-0 (pubk c)))
      (send (enc a b c nd-0 nb-0 nd-0 (pubk d))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nb-1 (pubk c))))
    ((recv (enc a b c nd-0 nb-0 nd-0 (pubk d)))
      (send (enc b c d nd-0 nb-0 nd-0 nd-0 (pubk a))))
    ((recv (enc a b d nd-0 nb-1 (pubk c)))
      (send (enc a b c nd-0 nb-1 nc-0 (pubk d)))))
  (label 571)
  (parent 162)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 572)
  (parent 163)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 573)
  (parent 163)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 574)
  (parent 164)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 575)
  (parent 164)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 576)
  (parent 164)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-2 (pubk d)))))
  (label 577)
  (parent 165)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 578)
  (parent 165)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 579)
  (parent 165)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 nb-3 text)
    (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-3) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (6 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-3 (pubk c)))))
  (label 580)
  (parent 166)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (6 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 3 resp1 2) nb-0 (6 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 581)
  (parent 166)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 5 resp1 2) nb-0 (6 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 582)
  (parent 166)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (6 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 3 resp1 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-2 (pubk d)))))
  (label 583)
  (parent 166)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 5 resp1 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-2 (pubk d)))))
  (label 584)
  (parent 166)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (6 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 7 2 resp2 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-2 (pubk d)))))
  (label 585)
  (parent 166)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 586)
  (parent 167)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 587)
  (parent 167)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-0 nc-1 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a b d nc-0 nb-1 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-2 (pubk d)))))
  (label 588)
  (parent 168)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-0 nc-1 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a b d nc-0 nb-1 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-2 (pubk d)))))
  (label 589)
  (parent 168)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp3 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-0 nc-1 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a b d nc-0 nb-1 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 590)
  (parent 168)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp3 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d))
    (enc a b c nc-0 nb-0 nc-1 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a b d nc-0 nb-1 (pubk c))
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 591)
  (parent 168)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 592)
  (parent 169)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 593)
  (parent 169)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 594)
  (parent 169)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 595)
  (parent 169)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nc-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nc-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-1) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 6 4 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nc-1 (pubk c))))
    ((recv (enc a b d nc-1 nc-1 (pubk c)))
      (send (enc a b c nc-1 nc-1 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-1 nb-0 nc-1 (pubk d)))
      (send (enc b c d nc-1 nb-0 nc-1 nd-0 (pubk a)))))
  (label 596)
  (parent 169)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 597)
  (parent 170)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 598)
  (parent 170)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((3 1) (5 0)) ((4 1) (0 1))
    ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 599)
  (parent 170)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 600)
  (parent 170)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nc-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nc-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-1) (nb nc-1) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 6 4 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nc-1 (pubk c))))
    ((recv (enc a b d nc-1 nc-1 (pubk c)))
      (send (enc a b c nc-1 nc-1 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-1 nc-1 nc-0 (pubk d)))
      (send (enc b c d nc-1 nc-1 nc-0 nd-0 (pubk a)))))
  (label 601)
  (parent 170)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (0 1)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-2 (pubk d)))))
  (label 602)
  (parent 171)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (0 1)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 603)
  (parent 171)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (0 1)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 604)
  (parent 171)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 605)
  (parent 172)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 606)
  (parent 172)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nc-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nc-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nc-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nc-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-1) (nb nc-1) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 6 4 resp2 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nc-1 (pubk c))))
    ((recv (enc a b d nc-1 nc-1 (pubk c)))
      (send (enc a b c nc-1 nc-1 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nc-1 (pubk c))))
    ((recv (enc a b d nc-1 nc-1 (pubk c)))
      (send (enc a b c nc-1 nc-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-1 nc-1 nc-0 (pubk d)))
      (send (enc b c d nc-1 nc-1 nc-0 nd-0 (pubk a)))))
  (label 607)
  (parent 172)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (0 1)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 608)
  (parent 173)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-1 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-1 nd-0 (pubk a)))))
  (label 609)
  (parent 173)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nc-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nc-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nc-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nc-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-1) (nb nc-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 6 4 resp2 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nc-1 (pubk c))))
    ((recv (enc a b d nc-1 nc-1 (pubk c)))
      (send (enc a b c nc-1 nc-1 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nc-1 (pubk c))))
    ((recv (enc a b d nc-1 nc-1 (pubk c)))
      (send (enc a b c nc-1 nc-1 nc-1 (pubk d))))
    ((recv (enc a b c nc-1 nc-1 nc-1 (pubk d)))
      (send (enc b c d nc-1 nc-1 nc-1 nd-0 (pubk a)))))
  (label 610)
  (parent 173)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nc-2 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-2 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 611)
  (parent 174)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-2 (pubk d)))))
  (label 612)
  (parent 174)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-2 (5 0)
    (enc a c d nc-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 613)
  (parent 174)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((2 1) (5 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-2 (pubk d)))))
  (label 614)
  (parent 174)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 4 resp2 2) nc-2 (5 0)
    (enc a c d nc-2 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 615)
  (parent 174)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-1 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 616)
  (parent 175)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 617)
  (parent 175)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 618)
  (parent 175)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((2 1) (5 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 619)
  (parent 175)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 4 resp2 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 620)
  (parent 175)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 621)
  (parent 176)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 622)
  (parent 176)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nb-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nb-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nb-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nb-0 nb-0 nb-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nb-0 nd-0 (pubk a)))))
  (label 623)
  (parent 176)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((2 1) (5 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 624)
  (parent 176)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 4 resp2 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))))
  (label 625)
  (parent 176)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-1 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 626)
  (parent 177)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-1 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-1 (pubk d)))))
  (label 627)
  (parent 177)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 628)
  (parent 178)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c)))))
  (label 629)
  (parent 178)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0))
    ((4 1) (0 1)) ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (4 0)
    (enc a b d nb-0 nb-0 (pubk c)) (enc a b d nb-0 nb-1 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 630)
  (parent 178)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nb-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (4 0)
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c)))))
  (label 631)
  (parent 178)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 nb-3 text)
    (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-3) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (6 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-3 (pubk c)))))
  (label 632)
  (parent 179)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (6 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 3 resp1 2) nb-0 (6 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-1 (pubk d)))))
  (label 633)
  (parent 179)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nb-2 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 5 resp1 2) nb-0 (6 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-1 (pubk d)))))
  (label 634)
  (parent 179)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (6 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 3 resp1 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 635)
  (parent 179)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 5 resp1 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d)))))
  (label 636)
  (parent 179)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (6 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 7 2 resp2 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d)))))
  (label 637)
  (parent 179)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nb-0 nd text) (a b c d name))
  (defstrand init 3 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb) (nb nb) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nb) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb) (nb nb) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb)
  (operation nonce-test (contracted (nb-1 nb) (nc-0 nc) (nd-0 nd)) nb
    (0 1) (enc a b c nb nb nc (pubk d)) (enc a b d nb nb (pubk c))
    (enc a b d nb nb-0 (pubk c)) (enc a c d nb (pubk b))
    (enc b c d nb nb nc nd (pubk a)))
  (traces
    ((send (enc a c d nb (pubk b)))
      (recv (enc b c d nb nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb (pubk c))))
    ((recv (enc a b d nb nb (pubk c)))
      (send (enc a b c nb nb nc (pubk d))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb-0 (pubk c))))
    ((recv (enc a b c nb nb nc (pubk d)))
      (send (enc b c d nb nb nc nd (pubk a))))
    ((recv (enc a c d nb (pubk b))) (send (enc a b d nb nb (pubk c)))))
  (label 638)
  (parent 180)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b))
    (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 639)
  (parent 180)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nc nb nd nb-0 text) (a b c d name))
  (defstrand init 3 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nc) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nb) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb-1 nc) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nc nc (pubk d)) (enc a b d nc nc (pubk c))
    (enc a b d nc nb (pubk c)) (enc a b d nc nb-0 (pubk c))
    (enc a c d nc (pubk b)) (enc b c d nc nc nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nc nc nd (pubk a)))
      (send (enc nc nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b d nc nc (pubk c)))
      (send (enc a b c nc nc nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nb (pubk c))))
    ((recv (enc a b c nc nc nc (pubk d)))
      (send (enc b c d nc nc nc nd (pubk a))))
    ((recv (enc a c d nc (pubk b)))
      (send (enc a b d nc nb-0 (pubk c)))))
  (label 640)
  (parent 181)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a b d nc-0 nb-1 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 641)
  (parent 181)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a b d nc-0 nb-1 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nb-1 (pubk c)))
      (send (enc a b c nc-0 nb-1 nc-1 (pubk d)))))
  (label 642)
  (parent 181)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nb-1 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a b d nc-0 nb-0 (pubk c)) (enc a b d nc-0 nb-1 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 643)
  (parent 181)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 nb-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c)))))
  (label 644)
  (parent 182)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d)))))
  (label 645)
  (parent 182)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (0 1))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 6 3 resp1 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d)))))
  (label 646)
  (parent 182)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-1 (5 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d)))))
  (label 647)
  (parent 182)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((3 1) (4 0)) ((4 1) (0 1))
    ((5 1) (4 0)) ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c)))))
  (label 648)
  (parent 183)
  (unrealized (0 1) (4 0) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (5 0))
    ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nb-0 (5 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 649)
  (parent 183)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nc nd text) (a b c d name))
  (defstrand init 3 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc) (nb nc) (nc nc) (a a) (b b) (c c) (d d))
  (defstrand resp1 2 (na nc) (nb nc) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc) (nb nc) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc)
  (operation nonce-test (contracted (nb nc) (nc-0 nc) (nd-0 nd)) nc
    (0 1) (enc a b c nc nc nc (pubk d)) (enc a b d nc nc (pubk c))
    (enc a c d nc (pubk b)) (enc b c d nc nc nc nd (pubk a)))
  (traces
    ((send (enc a c d nc (pubk b)))
      (recv (enc b c d nc nc nc nd (pubk a)))
      (send (enc nc nc nd (pubk b))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b d nc nc (pubk c)))
      (send (enc a b c nc nc nc (pubk d))))
    ((recv (enc a c d nc (pubk b))) (send (enc a b d nc nc (pubk c))))
    ((recv (enc a b c nc nc nc (pubk d)))
      (send (enc b c d nc nc nc nd (pubk a)))))
  (label 650)
  (parent 184)
  (unrealized)
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nb-0 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c)))))
  (label 651)
  (parent 184)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp2 2) nc-0 (0 1)
    (enc a b c nc-0 nc-0 nc-0 (pubk d)) (enc a b d nc-0 nc-0 (pubk c))
    (enc a c d nc-0 (pubk b)) (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 652)
  (parent 184)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nb-0 (pubk c)))
      (send (enc a b c nc-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 653)
  (parent 186)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nd-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nd-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nd-0) (nc nd-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nd-0) (nb nd-0) (nc nd-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nd-0)
  (operation nonce-test (displaced 6 4 resp3 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nd-0 (pubk b)))
      (recv (enc b c d nd-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nd-0 (pubk c))))
    ((recv (enc a b d nd-0 nd-0 (pubk c)))
      (send (enc a b c nd-0 nd-0 nd-0 (pubk d))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nb-0 (pubk c))))
    ((recv (enc a b c nd-0 nd-0 nd-0 (pubk d)))
      (send (enc b c d nd-0 nd-0 nd-0 nd-0 (pubk a))))
    ((recv (enc a b d nd-0 nb-0 (pubk c)))
      (send (enc a b c nd-0 nb-0 nc-0 (pubk d)))))
  (label 654)
  (parent 186)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 nb-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (6 0)) ((1 1) (2 0))
    ((2 1) (4 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1))
    ((6 1) (5 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (added-strand resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-1 (pubk c)))))
  (label 655)
  (parent 187)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((3 1) (5 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 3 resp1 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 656)
  (parent 187)
  (unrealized (0 1) (5 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nd-0 nc-1 text) (a b c d name))
  (defstrand init 3 (na nc-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nc-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-0) (nb nc-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nc-0) (nb nc-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((2 1) (5 0)) ((3 1) (2 0)) ((4 1) (0 1)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-0)
  (operation nonce-test (displaced 6 2 resp2 2) nc-0 (5 0)
    (enc a c d nc-0 (pubk b)))
  (traces
    ((send (enc a c d nc-0 (pubk b)))
      (recv (enc b c d nc-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nc-0 (pubk c))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-0 (pubk b)))
      (send (enc a b d nc-0 nb-0 (pubk c))))
    ((recv (enc a b c nc-0 nc-0 nc-0 (pubk d)))
      (send (enc b c d nc-0 nc-0 nc-0 nd-0 (pubk a))))
    ((recv (enc a b d nc-0 nc-0 (pubk c)))
      (send (enc a b c nc-0 nc-0 nc-1 (pubk d)))))
  (label 657)
  (parent 187)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nd-0 nc-0 text) (a b c d name))
  (defstrand init 3 (na nd-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nd-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nd-0) (nc nd-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nd-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nd-0) (nb nd-0) (nc nd-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp2 2 (na nd-0) (nb nd-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((1 1) (2 0)) ((2 1) (4 0))
    ((3 1) (2 0)) ((4 1) (5 0)) ((5 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nd-0)
  (operation nonce-test (displaced 6 4 resp3 2) nc-1 (5 0)
    (enc a c d nc-1 (pubk b)))
  (traces
    ((send (enc a c d nd-0 (pubk b)))
      (recv (enc b c d nd-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nd-0 (pubk c))))
    ((recv (enc a b d nd-0 nd-0 (pubk c)))
      (send (enc a b c nd-0 nd-0 nd-0 (pubk d))))
    ((recv (enc a c d nd-0 (pubk b)))
      (send (enc a b d nd-0 nb-0 (pubk c))))
    ((recv (enc a b c nd-0 nd-0 nd-0 (pubk d)))
      (send (enc b c d nd-0 nd-0 nd-0 nd-0 (pubk a))))
    ((recv (enc a b d nd-0 nd-0 (pubk c)))
      (send (enc a b c nd-0 nd-0 nc-0 (pubk d)))))
  (label 658)
  (parent 187)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nc-1 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 659)
  (parent 188)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nc-1 nb-0 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b c na nb-0 nc-1 (pubk d)))
      (send (enc b c d na nb-0 nc-1 nd-0 (pubk a)))))
  (label 660)
  (parent 188)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 661)
  (parent 189)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 662)
  (parent 189)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 663)
  (parent 190)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 664)
  (parent 190)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 nb-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-2 (pubk c)))))
  (label 665)
  (parent 191)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 666)
  (parent 191)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 667)
  (parent 191)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((5 1) (6 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 668)
  (parent 191)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 669)
  (parent 191)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 670)
  (parent 191)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((5 1) (6 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 671)
  (parent 191)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (6 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 7 4 resp2 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-1 (pubk c))))
    ((recv (enc a b d nc-1 nb-1 (pubk c)))
      (send (enc a b c nc-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-1 (pubk c))))
    ((recv (enc a b c nc-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nc-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 672)
  (parent 191)
  (unrealized (0 1) (2 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-2 (pubk d)))))
  (label 673)
  (parent 192)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 674)
  (parent 192)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-1 (pubk d)))
      (send (enc b c d na nb-0 nc-1 nd-0 (pubk a)))))
  (label 675)
  (parent 192)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 676)
  (parent 193)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 677)
  (parent 193)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 678)
  (parent 193)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp2 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d)))))
  (label 679)
  (parent 194)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 680)
  (parent 194)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 681)
  (parent 194)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d)))))
  (label 682)
  (parent 195)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-2 (pubk d)))))
  (label 683)
  (parent 195)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 684)
  (parent 195)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-2 (pubk d)))))
  (label 685)
  (parent 195)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-2) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-2)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-2 (pubk b)))
      (recv (enc b c d nb-2 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-0 (pubk c))))
    ((recv (enc a b d nb-2 nb-0 (pubk c)))
      (send (enc a b c nb-2 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-1 (pubk c))))
    ((recv (enc a b d nb-2 nb-1 (pubk c)))
      (send (enc a b c nb-2 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-2 (pubk c))))
    ((recv (enc a b d nb-2 nb-0 (pubk c)))
      (send (enc a b c nb-2 nb-0 nc-2 (pubk d)))))
  (label 686)
  (parent 195)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 nb-3 text)
    (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-3) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (4 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-3 (pubk c)))))
  (label 687)
  (parent 196)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 688)
  (parent 196)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 689)
  (parent 196)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d)))))
  (label 690)
  (parent 196)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-2) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-2)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-2 (pubk b)))
      (recv (enc b c d nb-2 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-0 (pubk c))))
    ((recv (enc a b d nb-2 nb-0 (pubk c)))
      (send (enc a b c nb-2 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-1 (pubk c))))
    ((recv (enc a b d nb-2 nb-1 (pubk c)))
      (send (enc a b c nb-2 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-2 (pubk c))))
    ((recv (enc a b d nb-2 nb-2 (pubk c)))
      (send (enc a b c nb-2 nb-2 nc-2 (pubk d)))))
  (label 691)
  (parent 196)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-1 (pubk d)) (enc a b c na nb-1 nc-0 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-1 (pubk d)))
      (send (enc b c d na nb-0 nc-1 nd-0 (pubk a)))))
  (label 692)
  (parent 197)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-1 (pubk d)) (enc a b c na nb-1 nc-0 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-1 nc-0 (pubk d)))
      (send (enc b c d na nb-1 nc-0 nd-0 (pubk a)))))
  (label 693)
  (parent 197)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-2 (pubk d)))))
  (label 694)
  (parent 198)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 695)
  (parent 198)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-0 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b c na nb-0 nc-1 (pubk d)))
      (send (enc b c d na nb-0 nc-1 nd-0 (pubk a)))))
  (label 696)
  (parent 198)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp2 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 697)
  (parent 199)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b c na nb-0 nc-0 (pubk d)))
      (send (enc b c d na nb-0 nc-0 nd-0 (pubk a)))))
  (label 698)
  (parent 199)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp3 2) na (0 1)
    (enc a b c na nb-0 nc-0 (pubk d)) (enc a b c na nb-1 nc-1 (pubk d))
    (enc a b d na nb-0 (pubk c)) (enc a b d na nb-1 (pubk c))
    (enc a b d na nb-2 (pubk c)) (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 699)
  (parent 199)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 700)
  (parent 200)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 701)
  (parent 200)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 702)
  (parent 200)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 nb-3 text)
    (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-3) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-3 (pubk c)))))
  (label 703)
  (parent 201)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 704)
  (parent 201)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((3 1) (6 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 705)
  (parent 201)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((5 1) (6 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b d na nb-2 (pubk c)))
      (send (enc a b c na nb-2 nc-2 (pubk d)))))
  (label 706)
  (parent 201)
  (unrealized (0 1) (2 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 707)
  (parent 201)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((3 1) (6 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d)))))
  (label 708)
  (parent 201)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-2) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((5 1) (6 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-2)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-2 (pubk b)))
      (recv (enc b c d nb-2 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-0 (pubk c))))
    ((recv (enc a b d nb-2 nb-0 (pubk c)))
      (send (enc a b c nb-2 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-1 (pubk c))))
    ((recv (enc a b d nb-2 nb-1 (pubk c)))
      (send (enc a b c nb-2 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-2 (pubk c))))
    ((recv (enc a b d nb-2 nb-2 (pubk c)))
      (send (enc a b c nb-2 nb-2 nc-2 (pubk d)))))
  (label 709)
  (parent 201)
  (unrealized (0 1) (2 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (6 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 7 4 resp2 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-1 (pubk c))))
    ((recv (enc a b d nc-1 nb-1 (pubk c)))
      (send (enc a b c nc-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-2 (pubk c))))
    ((recv (enc a b d nc-1 nb-2 (pubk c)))
      (send (enc a b c nc-1 nb-2 nc-2 (pubk d)))))
  (label 710)
  (parent 201)
  (unrealized (0 1) (2 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 nb-3 text)
    (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na na) (nb nb-3) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (added-strand resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a))))
    ((recv (enc a c d na (pubk b)))
      (send (enc a b d na nb-3 (pubk c)))))
  (label 711)
  (parent 202)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 712)
  (parent 202)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((3 1) (6 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 713)
  (parent 202)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (na nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na na) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na na) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na na) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na na) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((5 1) (6 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig na)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d na (pubk b)))
      (recv (enc b c d na nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-0 (pubk c))))
    ((recv (enc a b d na nb-0 (pubk c)))
      (send (enc a b c na nb-0 nc-0 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-1 (pubk c))))
    ((recv (enc a b d na nb-1 (pubk c)))
      (send (enc a b c na nb-1 nc-1 (pubk d))))
    ((recv (enc a c d na (pubk b))) (send (enc a b d na nb-2 (pubk c))))
    ((recv (enc a b c na nb-1 nc-1 (pubk d)))
      (send (enc b c d na nb-1 nc-1 nd-0 (pubk a)))))
  (label 714)
  (parent 202)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 1 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 715)
  (parent 202)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((3 1) (6 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 3 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 716)
  (parent 202)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-2) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-2) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-2) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-2) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((5 1) (6 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-2)
  (operation nonce-test (displaced 7 5 resp1 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nb-2 (pubk b)))
      (recv (enc b c d nb-2 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-0 (pubk c))))
    ((recv (enc a b d nb-2 nb-0 (pubk c)))
      (send (enc a b c nb-2 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-1 (pubk c))))
    ((recv (enc a b d nb-2 nb-1 (pubk c)))
      (send (enc a b c nb-2 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-2 (pubk b)))
      (send (enc a b d nb-2 nb-2 (pubk c))))
    ((recv (enc a b c nb-2 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-2 nb-1 nc-1 nd-0 (pubk a)))))
  (label 717)
  (parent 202)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (6 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 7 4 resp2 2) na (6 0)
    (enc a c d na (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-1 (pubk c))))
    ((recv (enc a b d nc-1 nb-1 (pubk c)))
      (send (enc a b c nc-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-2 (pubk c))))
    ((recv (enc a b c nc-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nc-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 718)
  (parent 202)
  (unrealized (0 1) (2 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 719)
  (parent 203)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 720)
  (parent 203)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-2 (pubk d)))))
  (label 721)
  (parent 204)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 722)
  (parent 204)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 723)
  (parent 204)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 724)
  (parent 205)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b c nb-0 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-1 nd-0 (pubk a)))))
  (label 725)
  (parent 205)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-1 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a b d nb-0 nb-2 (pubk c))
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 726)
  (parent 205)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-2 (pubk d)))))
  (label 727)
  (parent 206)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 728)
  (parent 206)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 729)
  (parent 206)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 nb-3 text)
    (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-3) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (4 0)) ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (4 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp1 2) nb-0 (6 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-3 (pubk c)))))
  (label 730)
  (parent 207)
  (unrealized (0 1) (4 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 3 resp1 2) nb-0 (6 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 731)
  (parent 207)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 5 resp1 2) nb-0 (6 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-2 (pubk c)))
      (send (enc a b c nb-0 nb-2 nc-2 (pubk d)))))
  (label 732)
  (parent 207)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 3 resp1 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-2 (pubk d)))))
  (label 733)
  (parent 207)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (2 0)) ((4 1) (2 0)) ((5 1) (6 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 5 resp1 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-2 (pubk d)))))
  (label 734)
  (parent 207)
  (unrealized (0 1) (4 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 3 resp1 2) nb-0 (6 0)
    (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-2 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 735)
  (parent 208)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (4 0))
    ((2 1) (0 1)) ((3 1) (6 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (4 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 3 resp1 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-2 (pubk d)))))
  (label 736)
  (parent 208)
  (unrealized (0 1))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-1) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-1 (pubk d))
    (enc a b c nb-0 nb-1 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-1 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-1 nc-0 nd-0 (pubk a)))))
  (label 737)
  (parent 209)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-1 (pubk d))
    (enc a b c nb-0 nb-1 nc-0 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 738)
  (parent 209)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp2 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-2 (pubk d)))))
  (label 739)
  (parent 210)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-0 nd-0 (pubk a)))))
  (label 740)
  (parent 210)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nc-0 nb-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (added-strand resp3 2) nb-0 (0 1)
    (enc a b c nb-0 nb-0 nc-0 (pubk d))
    (enc a b c nb-0 nb-0 nc-1 (pubk d)) (enc a b d nb-0 nb-0 (pubk c))
    (enc a b d nb-0 nb-1 (pubk c)) (enc a c d nb-0 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 741)
  (parent 210)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp2 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d)))))
  (label 742)
  (parent 211)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-0) (nc nc-0) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-0 nc-0 (pubk d)))
      (send (enc b c d nb-1 nb-0 nc-0 nd-0 (pubk a)))))
  (label 743)
  (parent 211)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (6 0))
    ((1 1) (2 0)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (0 1)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp3 2) nb-1 (0 1)
    (enc a b c nb-1 nb-0 nc-0 (pubk d))
    (enc a b c nb-1 nb-1 nc-1 (pubk d)) (enc a b d nb-1 nb-0 (pubk c))
    (enc a b d nb-1 nb-1 (pubk c)) (enc a b d nb-1 nb-2 (pubk c))
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 744)
  (parent 211)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 nb-3 text)
    (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-3) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp1 2) nb-1 (6 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-3 (pubk c)))))
  (label 745)
  (parent 212)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 1 resp1 2) nb-1 (6 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d)))))
  (label 746)
  (parent 212)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-2) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((5 1) (6 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 5 resp1 2) nb-1 (6 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b d nb-1 nb-2 (pubk c)))
      (send (enc a b c nb-1 nb-2 nc-2 (pubk d)))))
  (label 747)
  (parent 212)
  (unrealized (0 1) (2 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 1 resp1 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b d nb-0 nb-1 (pubk c)))
      (send (enc a b c nb-0 nb-1 nc-2 (pubk d)))))
  (label 748)
  (parent 212)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((5 1) (6 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 5 resp1 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-2 (pubk d)))))
  (label 749)
  (parent 212)
  (unrealized (0 1) (2 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nc-2 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nc-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nc-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-1) (nc nc-2) (a a) (b b) (c c)
    (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (6 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 7 4 resp2 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nc-1 (pubk c))))
    ((recv (enc a b d nc-1 nc-1 (pubk c)))
      (send (enc a b c nc-1 nc-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-1 (pubk c))))
    ((recv (enc a b d nc-1 nb-1 (pubk c)))
      (send (enc a b c nc-1 nb-1 nc-2 (pubk d)))))
  (label 750)
  (parent 212)
  (unrealized (0 1) (2 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 nb-3 text)
    (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-3) (a a) (b b) (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((0 0) (7 0))
    ((1 1) (0 1)) ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0))
    ((5 1) (4 0)) ((6 1) (2 0)) ((7 1) (6 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (added-strand resp1 2) nb-1 (6 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-3 (pubk c)))))
  (label 751)
  (parent 213)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 1 resp1 2) nb-1 (6 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 752)
  (parent 213)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nb-1 nc-1 nb-2 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-2) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((5 1) (6 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 5 resp1 2) nb-1 (6 0)
    (enc a c d nb-1 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-2 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 753)
  (parent 213)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-0) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-0) (nb nb-0) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-0) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-0) (nb nb-0) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (6 0))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-0)
  (operation nonce-test (displaced 7 1 resp1 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-0 (pubk b)))
      (recv (enc b c d nb-0 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-0 (pubk c))))
    ((recv (enc a b d nb-0 nb-0 (pubk c)))
      (send (enc a b c nb-0 nb-0 nc-1 (pubk d))))
    ((recv (enc a c d nb-0 (pubk b)))
      (send (enc a b d nb-0 nb-1 (pubk c))))
    ((recv (enc a b c nb-0 nb-0 nc-1 (pubk d)))
      (send (enc b c d nb-0 nb-0 nc-1 nd-0 (pubk a)))))
  (label 754)
  (parent 213)
  (unrealized (0 1) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nb-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nb-1) (nb nb-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nb-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nb-1) (nb nb-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (2 0)) ((5 1) (4 0))
    ((5 1) (6 0)) ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nb-1)
  (operation nonce-test (displaced 7 5 resp1 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nb-1 (pubk b)))
      (recv (enc b c d nb-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-0 (pubk c))))
    ((recv (enc a b d nb-1 nb-0 (pubk c)))
      (send (enc a b c nb-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b d nb-1 nb-1 (pubk c)))
      (send (enc a b c nb-1 nb-1 nc-1 (pubk d))))
    ((recv (enc a c d nb-1 (pubk b)))
      (send (enc a b d nb-1 nb-1 (pubk c))))
    ((recv (enc a b c nb-1 nb-1 nc-1 (pubk d)))
      (send (enc b c d nb-1 nb-1 nc-1 nd-0 (pubk a)))))
  (label 755)
  (parent 213)
  (unrealized (0 1) (2 0) (6 0))
  (comment "aborted"))

(defskeleton nsl4cm
  (vars (nb nc nd nb-0 nc-0 nc-1 nb-1 nd-0 text) (a b c d name))
  (defstrand init 3 (na nc-1) (nb nb) (nc nc) (nd nd) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-0) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nb-0) (nc nc-0) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nc-1) (a a) (b b) (c c) (d d))
  (defstrand resp2 2 (na nc-1) (nb nc-1) (nc nc-1) (a a) (b b) (c c)
    (d d))
  (defstrand resp1 2 (na nc-1) (nb nb-1) (a a) (b b) (c c) (d d))
  (defstrand resp3 2 (na nc-1) (nb nc-1) (nc nc-1) (nd nd-0) (a a) (b b)
    (c c) (d d))
  (precedes ((0 0) (1 0)) ((0 0) (3 0)) ((0 0) (5 0)) ((1 1) (0 1))
    ((2 1) (0 1)) ((3 1) (4 0)) ((4 1) (6 0)) ((5 1) (4 0))
    ((6 1) (2 0)))
  (non-orig (privk a) (privk b) (privk c) (privk d))
  (uniq-orig nc-1)
  (operation nonce-test (displaced 7 4 resp2 2) nb-2 (6 0)
    (enc a c d nb-2 (pubk b)))
  (traces
    ((send (enc a c d nc-1 (pubk b)))
      (recv (enc b c d nc-1 nb nc nd (pubk a)))
      (send (enc nb nc nd (pubk b))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-0 (pubk c))))
    ((recv (enc a b d nc-1 nb-0 (pubk c)))
      (send (enc a b c nc-1 nb-0 nc-0 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nc-1 (pubk c))))
    ((recv (enc a b d nc-1 nc-1 (pubk c)))
      (send (enc a b c nc-1 nc-1 nc-1 (pubk d))))
    ((recv (enc a c d nc-1 (pubk b)))
      (send (enc a b d nc-1 nb-1 (pubk c))))
    ((recv (enc a b c nc-1 nc-1 nc-1 (pubk d)))
      (send (enc b c d nc-1 nc-1 nc-1 nd-0 (pubk a)))))
  (label 756)
  (parent 213)
  (unrealized (0 1) (2 0))
  (comment "aborted"))
